<template>
  <v-expand-transition>
    <v-card append v-show="formExpensesType" v-model="formExpensesType">
      <v-app-bar dense color="cyan" dark>
        <v-toolbar-title>{{ title }}</v-toolbar-title>
        <v-spacer />

        <v-btn icon @click="formExpensesType = !formExpensesType">
          <v-icon>mdi-close</v-icon>
        </v-btn>
      </v-app-bar>
      <form>
        <v-card-text>
          <v-text-field
            v-model="editedItem.name"
            label="ประเภทของต้นทุนค่าใช้จ่าย"
            :error-messages="nameErrors"
            required
            @input="$v.editedItem.name.$touch()"
            @blur="$v.editedItem.name.$touch()"
          ></v-text-field>
          <v-text-field
            v-model="editedItem.detail"
            label="รายละเอียด"
            :error-messages="detailErrors"
            required
            @input="$v.editedItem.detail.$touch()"
            @blur="$v.editedItem.detail.$touch()"
          ></v-text-field>
        </v-card-text>

        <v-card-actions>
          <v-spacer />
          <v-btn color="light-blue darken-2" dark @click="handdleClearData"
            >Clear</v-btn
          >
          <v-btn :color="btnCollo" dark @click="handdleAddData">{{
            title
          }}</v-btn>
        </v-card-actions>
      </form>
    </v-card>
  </v-expand-transition>
</template>
<script>
import { validationMixin } from 'vuelidate'
import { required, minLength } from 'vuelidate/lib/validators'

import Swal from 'sweetalert2'

export default {
  mixins: [validationMixin],

  validations: {
    editedItem: {
      name: {
        required,
      },
      detail: {
        required,
        // minLength: minLength(10),
      },
    },
  },

  props: ['fid', 'typeID', 'setIndexEdit', 'setDefaultItem'],

  data: () => ({
    btnCollo: 'success',
    indexEdit: -1,
    editedItem: {
      id: null,
      name: '',
      detail: '',
      auth: '',
    },
    defaultItem: {
      id: null,
      name: '',
      detail: '',
      auth: '',
    },
  }),
  computed: {
    // validate
    nameErrors() {
      const errors = []
      if (!this.$v.editedItem.name.$dirty) return errors
      !this.$v.editedItem.name.required &&
        errors.push('กรุณากรอกประเภทของค่าใช้จ่าย')
      return errors
    },
    detailErrors() {
      const errors = []
      if (!this.$v.editedItem.detail.$dirty) return errors
      !this.$v.editedItem.detail.required &&
        errors.push('กรุณากรอกรายละเอียดประเภทของค่าใช้จ่าย')
      return errors
    },

    formExpensesType: {
      get() {
        return this.$nuxt.$store.state.expensestype.expand
      },
      set(newVal) {
        this.$store.commit('SET_FORM_EXPENSES_TYPE', newVal)
      },
    },
    title() {
      this.indexEdit = this.$nuxt.$store.state.expensestype.EditItem
      // this.defaultItem = this.setDefaultItem
      console.log(this.indexEdit)
      // return this.indexEdit === -1 ? 'เพิ่มข้อมูล' : 'แก้ไขข้อมูล'
      if (this.indexEdit === -1) {
        this.putFormadddata()
        this.editedItem = Object.assign({}, this.defaultItem)
        this.btnCollo = 'success'
        return 'เพิ่มข้อมูล'
      } else {
        this.putFormeditdata()
        this.btnCollo = 'warning'
        return 'แก้ไขข้อมูล'
      }
    },
  },
  mounted() {},
  methods: {
    searchData() {},
    putFormadddata() {
      this.editedItem = Object.assign({}, this.defaultItem)
    },
    putFormeditdata() {
      this.editedItem = Object.assign(
        {},
        this.$nuxt.$store.state.expensestype.EditData
      )
      // console.log(this.$nuxt.$store.state.expensestype.EditData)
    },
    handdleClearData() {
      // ลบ

      if (this.indexEdit === -1) {
        this.editedItem = Object.assign({}, this.defaultItem)
      }
    },
    handdleAddData() {
      // เพิ่มและแก้ไข

      this.$v.$touch()
      if (this.$v.$invalid) {
        console.log('Error')
      } else {
        if (this.indexEdit === -1) {
          // indexEdit != 1 (เพิ่ม)

          this.editedItem.id = this.$nuxt.$store.state.expensestype.TypeID
          this.editedItem.auth = this.$nuxt.$store.state.users.user.email
          // console.log('B sussess', this.editedItem.id)

          this.$store
            .dispatch('addDataExpensesType', this.editedItem)
            .then(() => {
              // console.log('A sussess', this.editedItem)

              this.editedItem = Object.assign({}, this.defaultItem)
              const Toast = Swal.mixin({
                toast: true,
                position: 'top',
                showConfirmButton: false,
                timer: 2000,
                timerProgressBar: true,
                didOpen: (toast) => {
                  toast.addEventListener('mouseenter', Swal.stopTimer)
                  toast.addEventListener('mouseleave', Swal.resumeTimer)
                },
              })

              Toast.fire({
                icon: 'success',
                title: 'บันทึกข้อมูลสำเร็จ',
              })
              this.$store.commit('SET_FORM_EXPENSES_TYPE', false)
            })
            .catch((error) => {
              setTimeout(() => {
                console.log('Error :', error.code)
              }, 2000)
            })
        } else {
          // indexEdit == 1 (แก้ไข)
          Swal.fire({
            title: 'คุณแน่ใจหรือไม่',
            text: 'คุณต้องการแก้ไขข้อมูลนี้',
            icon: 'question',
            showCancelButton: true,
            confirmButtonColor: '#FB8C00',
            cancelButtonColor: '#0288D1',
            confirmButtonText: 'ใช่, แก้ไขข้อมูล',
            cancelButtonText: 'ยกเลิก',
          }).then((result) => {
            if (result.isConfirmed) {
              Swal.fire(
                'แก้ไขข้อมูล',
                'คุณได้แก้ไขข้อมูลเรียบร้อยแล้ว',
                'success'
              )
              this.$store
                .dispatch('editDataExpensesType', this.editedItem)
                .then(() => {
                  this.editedItem = Object.assign({}, this.defaultItem)
                  this.$store.commit('SET_FORM_EXPENSES_TYPE', false)
                })
            }
          })
        }
      }
    },
  },
}
</script>
